## ex3.py
# AE3M33UI - Artificial Intellignece course, FEE CTU in Prague
#
# Exercise 3-1: Basis expansion with linear regression

import numpy as np
from matplotlib.pyplot import *
from sklearn import linear_model, pipeline

from mpg import *
from plotting import *
from mapping import *
from model_evaluation import *

## Load data for simple regression
X,y = load_mpg_for_simple_regression('disp', 'hp')
print('\n== Simple regression ==')
print('The shapes of X and y are:')
print(X.shape)
print(y.shape)

## Plot the input data
plot_xy_data(X, y, xlbl='disp', ylbl='hp')

## Fit linear regression model and plot it
lm = linear_model.LinearRegression()
lm.fit(X,y)
plot_1D_regr_model(lm)

## Compute its error
err = compute_model_error(lm, X, y, compute_err_MSE)
print('Degree 1 model: MSE = {:.3f}'.format(err))

## Fit a quadratic model and plot it
raise NotImplementedError
# <YOUR CODE HERE>

## Higher degree polynomials
plot_xy_data(X, y, xlbl='disp', ylbl='hp')

# Degrees of polynomials with the colors of the lines
degrees = [(1,'b'), (2,'r'), (3,'g'), (4,'y')]
# Array for legend descriptions
legstr = []   
for deg, color in degrees:
    raise NotImplementedError
    # <YOUR CODE HERE>
legend(legstr,loc='upper left')
 
